//#include "aifes_f32_fnn.h"
#include "aifes_q7_fnn.h"
uint8_t out_pins[] = {2, 3, 5, 6, 9, 10, 11, 12};
float outvals[8];

void setup() {
    Serial.begin(115200);

    //analogReference(INTERNAL); /*Uncomment if used with audio signals. Sets analog input range to 0 .. 1.1V*/
    for(int i = 0; i < 8; i++){
        pinMode(out_pins[i], OUTPUT);
    }
    //aifes_f32_fnn_create_model(); // Model initialization
    aifes_q7_fnn_create_model(); // Model initialization
}

void loop() {
    const int filtercoeff = 50;
    const float adcscale = 1;

    float adcval = 0;
    //Low-pass filtering of input values
    for(int i = 0; i<filtercoeff; i++)
    {
        adcval += analogRead(A0);
        delay(1);
    }
    adcval /= filtercoeff;
    adcval *= adcscale;

    float inval = adcval / 1023;
    //aifes_f32_fnn_inference(&inval, outvals); // Inference
    aifes_q7_fnn_inference(&inval, outvals);

    // Write values to LEDs
    // Pins 2 and 12 cannot output PWM. For these, analogWrite() defaults do digitalWrite().
    for(int i = 0; i < 8; i++)
    {
        uint8_t pin = out_pins[i];
        analogWrite(pin, (uint8_t)(255 * outvals[i]));
        if(pin == 12)
        {
            Serial.print(inval);
            Serial.print(": ");
            Serial.println(outvals[i]);
        }

    }
}